// -*- c++ -*-
/*
   This file has been generated by gtksig from ./../clist.gen_h. DO NOT MODIFY!!!
*/
#ifndef GTKMM_clist_HEADER
#define GTKMM_clist_HEADER
#include <gtk--/container.h>
#include <gtk--/scrollbar.h>
#include <gtk/gtkclist.h>
  struct Gtk_c_signals_CList : public Gtk_c_signals_Container {
    void (*select_row)(GtkCList*,gint, gint, GdkEventButton*);
    void (*unselect_row)(GtkCList*,gint, gint, GdkEventButton*);
    void (*click_column)(GtkCList*,gint);
  };
  class Gtk_CList;
  class Gtk_Class_Proxy_CList {
  public:
    typedef Gtk_CList CppObjectType;
    typedef GtkCList BaseObjectType;
    typedef GtkCListClass BaseClassType;
    struct proxy_Object {
      BaseObjectType object;
    };
    struct proxy_Class {
      BaseClassType parent_class;
      Gtk_c_signals_CList sigs;
    };
    static void class_init_function(proxy_Class *p);
    static void object_init_function(proxy_Object *);
    guint get_type();
    char *name;
    guint (*get_type_func_ptr)();
  };
#line 4 "./../clist.gen_h"

//: Multi-column list widget designed to handle very much data without 
//: performance problems
class Gtk_CList : public Gtk_Container
{
public:
#line 10 "./../clist.gen_h"

  Gtk_VScrollbar vscrollbar;
  Gtk_HScrollbar hscrollbar;
  
  static void cpp_class_init(GtkObject*);
  Gtk_CList(int columns, gchar * titles[] = 0);
  Gtk_CList(GtkCList *castitem);
  static bool isGtkCList(Gtk_Object *checkcast);

  // set the border style of the clist
  // <P>
  // valid choices are:
  // GTK_SHADOW_NONE, GTK_SHADOW_IN, GTK_SHADOW_OUT, GTK_SHADOW_ETCHED_IN,
  // GTK_SHADOW_ETCHED_OUT
  void set_border(GtkShadowType border);

  // set the clist's selection mode
  void set_selection_mode(GtkSelectionMode mode);

  // set policy on the scrollbar, to either show them all the time
  // or show them only when they are needed, ie., when there is more than
  // one page of information
  // <P>
  // valid choices are:
  // GTK_POLICY_ALWAYS, GTK_POLICY_AUTOMATIC
  void set_policy(GtkPolicyType vscrollbar_policy,
		  GtkPolicyType hscrollbar_policy);

  // freeze all visual updates of the list, and then thaw the list after you
  // have made a number of changes and the updates wil occure in a more
  // efficent mannor than if you made them on a unfrozen list
  void freeze();
  // thaw the list (see <A HREF="#freeze">freeze</A>)
  void thaw();

  // show the column title buttons
  void column_titles_show();
  // hide the column title buttons
  void column_titles_hide();
  // set the column title to be a active title (responds to button presses,
  // prelights, and grabs keyboard focus)
  void column_title_active(gint column);
  // set the column title to be passive where it acts as just a title
  void column_title_passive(gint column);
  // set the column titles to be a active (respond to button presses,
  // prelight, and grab keyboard focus)
  void column_titles_active();
  // set the column titles to be passive where they act as just a title
  void column_titles_passive();

  // set the title in the column title button
  void set_column_title(gint column, const string &title);
  // set a widget instead of a title for the column title button
  void set_column_widget(gint column, Gtk_Widget *widget);
  // set the justification on a column
  // <P>
  // valid choices are:
  // GTK_JUSTIFY_LEFT, GTK_JUSTIFY_RIGHT, GTK_JUSTIFY_CENTER,
  // GTK_JUSTIFY_FILL
  void set_column_justification(gint column, GtkJustification justification);
  // set the pixel width of a column; this is a necessary step in
  // creating a CList because otherwise the column width is chozen from
  // the width of the column title, which will never be right
  void set_column_width(gint column, gint width);

  // change the height of the rows, the default is the hight of the current
  // font
  void set_row_height(gint height);

  // scroll the viewing area of the list to the given column
  // and row; row_align and col_align are between 0-1 representing the
  // location the row should appear on the screnn, 0.0 being top or left,
  // 1.0 being bottom or right; if row or column is -1 then then there
  // is no change
  void moveto(gint row, gint column,
	      gfloat row_align, gfloat col_align);

  // returns whether the row is visible
  bool row_is_visible(gint row);

  // returns the cell type, which is one of
  // GTK_CELL_EMPTY, GTK_CELL_TEXT, GTK_CELL_PIXMAP, GTK_CELL_PIXTEXT, 
  // GTK_CELL_WIDGET
  GtkCellType get_cell_type(gint row, gint column);

  // sets a given cell's text, replacing it's current contents
  void set_text(gint row, gint column, const string &text);
  // returns 1 on success
  gint get_text(gint row, gint column, gchar **text);

  // sets a given cell's pixmap, replacing it's current contents
  void set_pixmap(gint row, gint column,
		  GdkPixmap *pixmap, GdkBitmap *mask);
  // returns 1 on success
  // any of the return pointer can be NULL if you are not interested
  gint get_pixmap(gint row, gint column,
		  GdkPixmap **pixmap, GdkBitmap **mask);

  // sets a given cell's pixmap and text, replacing it's current contents
  void set_pixtext(gint row, gint column, const string &text,
		   guint8 spacing,
		   GdkPixmap *pixmap, GdkBitmap *mask);
  // any of the return pointer can be NULL if you are not interested
  gint get_pixtext(gint row, gint column, gchar **text,
		   guint8 *spacing,
		   GdkPixmap **pixmap, GdkBitmap **mask);

  // sets the foreground color of a row, the color must already
  // be allocated
  void set_foreground(gint row, GdkColor *color);

  // sets the background color of a row, the color must already
  // be allocated
  void set_background(gint row, GdkColor *color);

  // this sets a horizontal and vertical shift for drawing
  // the contents of a cell; it can be positive or negitive; this is
  // partuculary useful for indenting items in a column
  void set_shift(gint row, gint column,
		 gint vertical, gint horizontal);

  // append returns the index of the row you just added, making
  // it easier to append and modify a row<p>
  // Example:
  // <pre>
  // gchar **row = new gchar*[num_of_columns];
  // row[0]="cell1";
  // row[1]="cell2";
  // ...
  // row[num_of_columns-1]="cellN-1";
  // clist->append(row);
  // </pre>
  gint append(gchar* text[]);

  // inserts a row at index row
  // Note: this is gtk_clist_insert() in gtk, but renamed here to
  //       insert_row()
  void insert_row(gint row, gchar* text[]);

  // removes row at index row
  // Note: this is gtk_clist_remove() in gtk, but renamed here to
  //       remove_row()
  void remove_row(gint row);

  // sets a arbitrary data pointer for a given row
  void set_row_data(gint row, gpointer data);
  // returns the data set for a row
  gpointer get_row_data(gint row);

  
  // sets a data pointer for a given row with destroy notification
  void set_row_data_full(gint row,
                         gpointer data,
			 GtkDestroyNotify destroy);
  // given a data pointer, find the first (and hopefully only!)
  // row that points to that data, or -1 if none do
  gint find_row_from_data(gpointer data);

  // force selection of a row
  void cause_select_row(gint row, gint column);
  // force unselection of a row
  void cause_unselect_row(gint row, gint column);

  // clear the entire list -- this is much faster than removing each item
  // with remove.
  void clear();

  

/* THIS ONE REMOVED, we dont use nonconst reference arguments in gtk--
   
  // return the row column corresponding to the x and y coordinates
  // <P> reference and pointer style available
  //gint get_selection_info(gint x, gint y, gint &row, gint &column);
*/

  // return the row column corresponding to the x and y coordinates
  // <P> reference and pointer style available
  gint get_selection_info(gint x, gint y, gint *row, gint *column);
 
 
#line 199 "./../clist.gen_h"
  // signal emitted on row selection
  // (row, column, event)
  Signal_proxy3<GtkObject,gint, gint, GdkEventButton*> select_row;
protected:
  virtual void select_row_impl(gint p1, gint p2, GdkEventButton* p3);
public:
  static void select_row_callback(GtkCList *o,gint p1, gint p2, GdkEventButton* p3);
#line 201 "./../clist.gen_h"

  // signal emitted on row unselection
  // (row, column, event)
  Signal_proxy3<GtkObject,gint, gint, GdkEventButton*> unselect_row;
protected:
  virtual void unselect_row_impl(gint p1, gint p2, GdkEventButton* p3);
public:
  static void unselect_row_callback(GtkCList *o,gint p1, gint p2, GdkEventButton* p3);
#line 204 "./../clist.gen_h"

#line 206 "./../clist.gen_h"
  // signal emitted by clicking on a title ?
  // (column)
  Signal_proxy1<GtkObject,gint> click_column;
protected:
  virtual void click_column_impl(gint p1);
public:
  static void click_column_callback(GtkCList *o,gint p1);
#line 208 "./../clist.gen_h"



  typedef GtkCList BaseObjectType;
  static Gtk_Class_Proxy_CList c_class; 
  virtual Gtk_c_signals_Base *internal_getsignalbase();
  static void cpp_class_init(GtkCListClass *o,Gtk_c_signals_CList *s) {
    Gtk_Container::cpp_class_init((GtkContainerClass *)o,s);
    s->select_row=o->select_row;
    o->select_row=select_row_callback;
    s->unselect_row=o->unselect_row;
    o->unselect_row=unselect_row_callback;
    s->click_column=o->click_column;
    o->click_column=click_column_callback;
  }
#line 210 "./../clist.gen_h"


  GtkCList* gtkobj() const { return GTK_CLIST(gtkobject); }

};


#endif
